﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.TeamFoundation.Client;
using Microsoft.TeamFoundation.VersionControl.Client;
using Microsoft.TeamFoundation.Framework.Client;
using System.Windows.Forms;
using Microsoft.TeamFoundation.Proxy;
using System.Net;
using Microsoft.TeamFoundation.Server;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.TestManagement.Client;
using Microsoft.TeamFoundation;
using Microsoft.TeamFoundation.WorkItemTracking.Client;
using System.Diagnostics;
using System.Configuration;

namespace MyTfsStoryBoard
{
    public class TfsRepository
    {
        public static TeamProject[] GetAllProjects()
        {
            var tfs = TfsTeamProjectCollectionFactory.GetTeamProjectCollection(new Uri(ConfigurationManager.AppSettings["TfsUri"]));
            var versionControl = tfs.GetService<VersionControlServer>();
            return versionControl.GetAllTeamProjects(true);
        }

        public static ProjectCollection GetAllIterations()
        {
            var tfs = TfsTeamProjectCollectionFactory.GetTeamProjectCollection(new Uri(ConfigurationManager.AppSettings["TfsUri"]));
            var wiStore = tfs.GetService<WorkItemStore>();

            return wiStore.Projects;
        }

        public static TeamProject GetProjectDetailsByName(string projectName)
        {
            var tfs = TfsTeamProjectCollectionFactory.GetTeamProjectCollection(new Uri(ConfigurationManager.AppSettings["TfsUri"]));
            var vsStore = tfs.GetService<VersionControlServer>();

            return vsStore.TryGetTeamProject(projectName);
        }

            //var projects = versionControl.ListAllProjects();
            //var somethingelse = versionControl.GetProject(@"vstfs:///Classification/TeamProject/d38a6834-050d-43fd-b4b0-7930eadde619");


            // var myService = tfs.GetService<TswaClientHyperlinkService>();
            // var myUrl = myService.GetChangesetDetailsUrl(21);

            // var anotherservice = tfs.GetService<IBuildServer>();
            // var whatNow = anotherservice.QueryBuildControllers(true);
            // var configServer = versionControl.GetTeamProject("Temp_UK_1");
            // var userInfo = configServer.VersionControlServer.AuthorizedUser;            
            
            // var cDetails = versionControl.GetChangeset(123);

            //var testManagementService = tfs.GetService<ILinking>();
            //Microsoft.TeamFoundation.ArtifactId a = new ArtifactId();
            //a.ArtifactType = "Changeset";
            //a.ToolSpecificId = "21";
            //var testControllers = testManagementService.GetArtifactUrlExternal(@"vstfs:///VersionControl/Changeset/21");

            //var processTemplates = tfs.GetService<IProcessTemplates>();
            //var templateName = processTemplates.GetTemplateNames();
            //int index = processTemplates.GetTemplateIndex(templateName.Name);
            //string templateFile = processTemplates.GetTemplateData(index);

            //var wiStore = tfs.GetService<WorkItemStore>();
            //var wiLinkTypes = wiStore.WorkItemLinkTypes;

            
            

  

    }
}
